## valijson 0.7+repack

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.2)
project(valijson)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

option(valijson_BUILD_EXAMPLES "Build valijson examples." FALSE)
option(valijson_BUILD_TESTS "Build valijson test suite." FALSE)
option(valijson_EXCLUDE_BOOST "Exclude Boost when building test suite." FALSE)
option(valijson_USE_EXCEPTIONS "Use exceptions in valijson and included libs." TRUE)

if(MSVC)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
else()
    include(CheckCXXCompilerFlag)
    CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
    if(!COMPILER_SUPPORTS_CXX11)
        message(FATAL_ERROR "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
    endif()

    # Suppress boost warnings that aren't relevant to the test suite
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DBOOST_BIND_GLOBAL_PLACEHOLDERS")

    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall")
    SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0")
endif()

add_library(valijson INTERFACE)
# create alias, so that user could always write target_link_libraries(... ValiJSON::valijson)
# despite of valijson target is imported or not
add_library(ValiJSON::valijson ALIAS valijson)

include(GNUInstallDirs)
target_include_directories(valijson INTERFACE
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

if(valijson_USE_EXCEPTIONS)
    target_compile_definitions(valijson INTERFACE -DVALIJSON_USE_EXCEPTIONS=1)
endif()

install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

install(TARGETS valijson
    EXPORT valijsonConfig
    DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(EXPORT valijsonConfig
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/valijson"
)

if(NOT valijson_BUILD_TESTS AND NOT valijson_BUILD_EXAMPLES)
    return()
endif()

if(valijson_USE_EXCEPTIONS)
    add_compile_definitions(VALIJSON_USE_EXCEPTIONS=1)
else()
    add_compile_definitions(_HAS_EXCEPTIONS=0)
    add_compile_definitions(BOOST_NO_EXCEPTIONS)
    add_compile_definitions(JSON_USE_EXCEPTION=0)
    add_compile_definitions(VALIJSON_USE_EXCEPTIONS=0)
endif()

find_package(Poco OPTIONAL_COMPONENTS JSON)
find_package(Qt5Core)

# jsoncpp library
add_library(jsoncpp
    thirdparty/jsoncpp-1.9.5/src/lib_json/json_reader.cpp
    thirdparty/jsoncpp-1.9.5/src/lib_json/json_value.cpp
    thirdparty/jsoncpp-1.9.5/src/lib_json/json_writer.cpp
)

target_include_directories(jsoncpp SYSTEM PRIVATE thirdparty/jsoncpp-1.9.5/include)
set_target_properties(jsoncpp PROPERTIES ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/thirdparty/jsoncpp-1.9.5)

add_library(json11
    thirdparty/json11-ec4e452/json11.cpp
)

target_include_directories(json11 SYSTEM PRIVATE thirdparty/json11-ec4e452)
set_target_properties(json11 PROPERTIES ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/thirdparty/json11-ec4e452)

# yaml-cpp library
file(GLOB yamlcpp_SOURCES "thirdparty/yaml-cpp-0.7.0/src/*.cpp")
add_library(yamlcpp ${yamlcpp_SOURCES})

target_include_directories(yamlcpp SYSTEM PRIVATE thirdparty/yamlcpp-0.7.0/include)
set_target_properties(yamlcpp PROPERTIES ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/thirdparty/yamlcpp-0.7.0)

# Not all of these are required for examples build it doesn't hurt to include them
include_directories(include SYSTEM
    thirdparty/gtest-1.11.0/include
    thirdparty/json11-ec4e452
    thirdparty/jsoncpp-1.9.5/include
    thirdparty/rapidjson-48fbd8c/include
    thirdparty/picojson-1.3.0
    thirdparty/nlohmann-json-3.1.2
    thirdparty/yaml-cpp-0.7.0/include
)

if(valijson_BUILD_TESTS)
    if(NOT valijson_EXCLUDE_BOOST)
        find_package(Boost)
    endif()

    # Build local gtest
    set(gtest_force_shared_crt ON)
    option(BUILD_GMOCK FALSE)
    option(INSTALL_GTEST FALSE)
    add_subdirectory(thirdparty/gtest-1.11.0)

    set(TEST_SOURCES
        tests/test_adapter_comparison.cpp
        tests/test_fetch_absolute_uri_document_callback.cpp
        tests/test_fetch_urn_document_callback.cpp
        tests/test_json_pointer.cpp
        tests/test_json11_adapter.cpp
        tests/test_jsoncpp_adapter.cpp
        tests/test_nlohmann_json_adapter.cpp
        tests/test_rapidjson_adapter.cpp
        tests/test_picojson_adapter.cpp
        tests/test_poly_constraint.cpp
        tests/test_validation_errors.cpp
        tests/test_validator.cpp
        tests/test_yaml_cpp_adapter.cpp
    )

    set(TEST_LIBS gtest gtest_main jsoncpp json11 yamlcpp)

    if(Boost_FOUND)
        include_directories(${Boost_INCLUDE_DIRS})

        # Property Trees have been in Boost since 1.41.0, so we just assume they're present
        list(APPEND TEST_SOURCES tests/test_property_tree_adapter.cpp)

        # Boost.JSON was introduced in Boost 1.75.0, so we should check for its presence before
        # including the unit tests for boost_json_adapter
        include(CheckIncludeFileCXX)
        set (CMAKE_REQUIRED_INCLUDES ${Boost_INCLUDE_DIRS})
        check_include_file_cxx("boost/json.hpp" BOOST_JSON_HPP_FOUND)
        if(${BOOST_JSON_HPP_FOUND})
            list(APPEND TEST_SOURCES tests/test_boost_json_adapter.cpp)
        else()
            message(WARNING
                "boost/json.hpp not found; tests for boost_json_adapter will not be built. "
                "If you have recently upgraded Boost to 1.75.0 or later, you may need to clear "
                "your CMake cache for the header to be found.")
        endif()
    endif()

    if(Poco_FOUND)
        include_directories(${Poco_INCLUDE_DIRS})
        list(APPEND TEST_SOURCES tests/test_poco_json_adapter.cpp)
        list(APPEND TEST_LIBS ${Poco_Foundation_LIBRARIES} ${Poco_JSON_LIBRARIES})
    endif()

    if(Qt5Core_FOUND)
        include_directories(${Qt5Core_INCLUDE_DIRS})
        list(APPEND TEST_LIBS Qt5::Core)
        list(APPEND TEST_SOURCES tests/test_qtjson_adapter.cpp)
    endif()

    # Unit tests executable
    add_executable(test_suite ${TEST_SOURCES})
    if(NOT valijson_USE_EXCEPTIONS)
        if(MSVC)
            if(CMAKE_CXX_FLAGS MATCHES "/EHsc ")
                string(REPLACE "/EHsc" "/EHs-c-" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
            else()
                target_compile_options(test_suite PUBLIC /EHs-c-)
            endif()
        else()
            target_compile_options(test_suite PUBLIC -fno-exceptions)
        endif()
    endif()

    if(NOT MSVC)
        set_target_properties(test_suite PROPERTIES COMPILE_FLAGS " -pedantic -Werror -Wshadow -Wunused")
    endif()

    if (MSVC)
        target_compile_options(test_suite PRIVATE "/bigobj")
    endif()

    # Definition for using picojson
    set_target_properties(test_suite PROPERTIES COMPILE_DEFINITIONS "PICOJSON_USE_INT64")

    if(Boost_FOUND)
        add_compile_definitions(BOOST_ALL_DYN_LINK)
        set(Boost_USE_STATIC_LIBS OFF)
        set(Boost_USE_MULTITHREADED ON)
        set(Boost_USE_STATIC_RUNTIME OFF)
        target_compile_definitions(test_suite PRIVATE "VALIJSON_BUILD_BOOST_PROPERTY_TREE_ADAPTER")
        if(${BOOST_JSON_HPP_FOUND})
            target_compile_definitions(test_suite PRIVATE "VALIJSON_BUILD_BOOST_JSON_ADAPTER")
        endif()
    endif()

    if(Poco_FOUND)
        target_compile_definitions(test_suite PRIVATE "VALIJSON_BUILD_POCO_ADAPTER")
    endif()

    if(Qt5Core_FOUND)
        target_compile_definitions(test_suite PRIVATE "VALIJSON_BUILD_QT_ADAPTER")
    endif()

    target_link_libraries(test_suite ${TEST_LIBS} ${Boost_LIBRARIES})
endif()

if(valijson_BUILD_EXAMPLES)
    find_package(curlpp)
    include_directories(SYSTEM)

    add_executable(custom_schema
        examples/custom_schema.cpp
    )

    add_executable(external_schema
        examples/external_schema.cpp
    )

    add_executable(array_iteration_basics
        examples/array_iteration_basics.cpp
    )

    add_executable(array_iteration_template_fn
        examples/array_iteration_template_fn.cpp
    )

    add_executable(object_iteration
        examples/object_iteration.cpp
    )

    add_executable(json_pointers
        examples/json_pointers.cpp
    )

    add_executable(remote_resolution_local_file
        examples/remote_resolution_local_file.cpp
    )

    add_executable(valijson_nlohmann_bundled_test
        examples/valijson_nlohmann_bundled_test.cpp
    )

    if(curlpp_FOUND)
        include_directories(${curlpp_INCLUDE_DIR})

        add_executable(remote_resolution_url
            examples/remote_resolution_url.cpp
        )

        target_link_libraries(remote_resolution_url curl ${curlpp_LIBRARIES})
    endif()

    target_link_libraries(custom_schema ${Boost_LIBRARIES})
    target_link_libraries(external_schema ${Boost_LIBRARIES})
    target_link_libraries(array_iteration_basics jsoncpp)
    target_link_libraries(array_iteration_template_fn jsoncpp)
    target_link_libraries(object_iteration jsoncpp)
    target_link_libraries(json_pointers)
endif()

=== debian/changelog ===
valijson (0.7+repack-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Mon, 25 Jul 2022 15:14:59 -0700

valijson (0.6+repack-2) unstable; urgency=medium

  * Source-only reupload to allow the migration to testing

 -- Dima Kogan <dkogan@debian.org>  Fri, 24 Jun 2022 13:17:51 -0700

valijson (0.6+repack-1) unstable; urgency=medium

  * Initial upload to Debian (Closes: #1011398)

 -- Dima Kogan <dkogan@debian.org>  Sun, 06 Feb 2022 22:30:59 -0800

=== debian/control ===
Source: valijson
Section: libdevel
Priority: optional
Maintainer: Dima Kogan <dkogan@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libjson11-1-dev,
               libjsoncpp-dev,
               nlohmann-json3-dev,
               picojson-dev,
               libyaml-cpp-dev,
               libpoco-dev,
               qtbase5-dev,
               rapidjson-dev,
               libgtest-dev
Standards-Version: 4.6.0
Homepage: https://github.com/tristanpenman/valijson
Vcs-Git: https://salsa.debian.org/debian/valijson.git
Vcs-Browser: https://salsa.debian.org/debian/valijson

Package: libvalijson-dev
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends},
         libjson11-1-dev,
         libjsoncpp-dev,
         nlohmann-json3-dev,
         picojson-dev,
         libyaml-cpp-dev,
         libpoco-dev,
         qtbase5-dev,
         rapidjson-dev
Description: Header-only C++ library for JSON Schema validation
 Valijson is a header-only JSON Schema validation library for C++11.
 .
 Valijson provides a simple validation API that allows you to load JSON Schemas,
 and validate documents loaded by one of several supported parser libraries.
 .
 The goal of this project is to support validation of all constraints available
 in JSON Schema v7, while being competitive with the performance of a
 hand-written schema validator.

## valijson 1.0+repack

=== CMakeLists.txt ===
--- 
+++ 
@@ -67,37 +67,37 @@
 
 # jsoncpp library
 add_library(jsoncpp
-    thirdparty/jsoncpp-1.9.5/src/lib_json/json_reader.cpp
-    thirdparty/jsoncpp-1.9.5/src/lib_json/json_value.cpp
-    thirdparty/jsoncpp-1.9.5/src/lib_json/json_writer.cpp
-)
-
-target_include_directories(jsoncpp SYSTEM PRIVATE thirdparty/jsoncpp-1.9.5/include)
-set_target_properties(jsoncpp PROPERTIES ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/thirdparty/jsoncpp-1.9.5)
+    thirdparty/jsoncpp/src/lib_json/json_reader.cpp
+    thirdparty/jsoncpp/src/lib_json/json_value.cpp
+    thirdparty/jsoncpp/src/lib_json/json_writer.cpp
+)
+
+target_include_directories(jsoncpp SYSTEM PRIVATE thirdparty/jsoncpp/include)
+set_target_properties(jsoncpp PROPERTIES ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/thirdparty/jsoncpp)
 
 add_library(json11
-    thirdparty/json11-ec4e452/json11.cpp
-)
-
-target_include_directories(json11 SYSTEM PRIVATE thirdparty/json11-ec4e452)
-set_target_properties(json11 PROPERTIES ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/thirdparty/json11-ec4e452)
+    thirdparty/json11/json11.cpp
+)
+
+target_include_directories(json11 SYSTEM PRIVATE thirdparty/json11)
+set_target_properties(json11 PROPERTIES ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/thirdparty/json11)
 
 # yaml-cpp library
-file(GLOB yamlcpp_SOURCES "thirdparty/yaml-cpp-0.7.0/src/*.cpp")
+file(GLOB yamlcpp_SOURCES "thirdparty/yaml-cpp/src/*.cpp")
 add_library(yamlcpp ${yamlcpp_SOURCES})
 
-target_include_directories(yamlcpp SYSTEM PRIVATE thirdparty/yamlcpp-0.7.0/include)
-set_target_properties(yamlcpp PROPERTIES ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/thirdparty/yamlcpp-0.7.0)
+target_include_directories(yamlcpp SYSTEM PRIVATE thirdparty/yamlcpp/include)
+set_target_properties(yamlcpp PROPERTIES ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/thirdparty/yamlcpp)
 
 # Not all of these are required for examples build it doesn't hurt to include them
 include_directories(include SYSTEM
-    thirdparty/gtest-1.11.0/include
-    thirdparty/json11-ec4e452
-    thirdparty/jsoncpp-1.9.5/include
-    thirdparty/rapidjson-48fbd8c/include
-    thirdparty/picojson-1.3.0
-    thirdparty/nlohmann-json-3.1.2
-    thirdparty/yaml-cpp-0.7.0/include
+    thirdparty/googletest/include
+    thirdparty/json11
+    thirdparty/jsoncpp/include
+    thirdparty/rapidjson/include
+    thirdparty/picojson
+    thirdparty/nlohmann-json/include
+    thirdparty/yaml-cpp/include
 )
 
 if(valijson_BUILD_TESTS)
@@ -109,7 +109,7 @@
     set(gtest_force_shared_crt ON)
     option(BUILD_GMOCK FALSE)
     option(INSTALL_GTEST FALSE)
-    add_subdirectory(thirdparty/gtest-1.11.0)
+    add_subdirectory(thirdparty/googletest)
 
     set(TEST_SOURCES
         tests/test_adapter_comparison.cpp

=== debian/changelog ===
valijson (1.0+repack-2) unstable; urgency=medium

  * Removed support for json11 (Closes: #1026372)

 -- Dima Kogan <dkogan@debian.org>  Mon, 19 Dec 2022 22:02:09 -0800

valijson (1.0+repack-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Fri, 04 Nov 2022 09:52:24 -0700

valijson (0.7+repack-2) unstable; urgency=medium

  * Source-only reupload

 -- Dima Kogan <dkogan@debian.org>  Mon, 26 Sep 2022 21:24:54 -0700

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

%:
	dh $@

# This is a header-only library. We only build the test suite. If we're not
# running the tests, there isn't anything to build

# >>>>>>>>>>>>>>>>>>>>>>>
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))

# We're testing stuff, so I build the tests

# The boost JSON parser is in boost>=1.75, but currently debian only has 1.74.
# So I disable that
override_dh_auto_configure:
	dh_auto_configure -- \
		-Dvalijson_INSTALL_HEADERS=ON \
		-Dvalijson_EXCLUDE_BOOST=ON \
		-Dvalijson_BUILD_TESTS=ON
override_dh_auto_test:
	cd obj-$(DEB_HOST_MULTIARCH) && ./test_suite

# >>>>>>>>>>>>>>>>>>>>>>>
else
# <<<<<<<<<<<<<<<<<<<<<<<

# Not testing stuff. I don't build anything
override_dh_auto_configure:
	dh_auto_configure -- \
		-Dvalijson_INSTALL_HEADERS=ON \
		-Dvalijson_EXCLUDE_BOOST=ON \
		-Dvalijson_BUILD_TESTS=OFF

override_dh_auto_build:
	true

override_dh_auto_test:
	true
endif
# <<<<<<<<<<<<<<<<<<<<<<<


# Everything is small. Compressing creates extra work for little benefit, so I
# don't do it
override_dh_compress:
	dh_compress -X.cpp -XREADME

## valijson 1.0.3+repack

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.1.2)
+cmake_minimum_required(VERSION 3.5.1)
 project(valijson)
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
@@ -124,6 +124,7 @@
         tests/test_poly_constraint.cpp
         tests/test_validation_errors.cpp
         tests/test_validator.cpp
+        tests/test_validator_with_custom_regular_expression_engine.cpp
         tests/test_yaml_cpp_adapter.cpp
     )
 
@@ -237,6 +238,10 @@
         examples/json_pointers.cpp
     )
 
+    add_executable(picojson_format_test
+        examples/picojson_format_test.cpp
+    )
+
     add_executable(remote_resolution_local_file
         examples/remote_resolution_local_file.cpp
     )

=== debian/changelog ===
valijson (1.0.3+repack-2) unstable; urgency=medium

  * Fixed test suite failure on i386 (Closes: #1103128)

 -- Dima Kogan <dkogan@debian.org>  Thu, 24 Apr 2025 10:02:35 -0700

valijson (1.0.3+repack-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Sun, 22 Dec 2024 19:10:34 -0800

valijson (1.0+repack-3) unstable; urgency=medium

  * Build with g++-14 (Closes: #1041090)

 -- Dima Kogan <dkogan@debian.org>  Sat, 26 Aug 2023 19:55:31 -0700

## valijson 1.0.6+repack

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.5.1)
+cmake_minimum_required(VERSION 3.10.0)
 project(valijson)
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
@@ -7,20 +7,32 @@
 option(valijson_BUILD_TESTS "Build valijson test suite." FALSE)
 option(valijson_EXCLUDE_BOOST "Exclude Boost when building test suite." FALSE)
 option(valijson_USE_EXCEPTIONS "Use exceptions in valijson and included libs." TRUE)
+
+option(valijson_USE_BOOST_REGEX "Use boost::regex instead of std::regex internally." FALSE)
+mark_as_advanced(valijson_USE_BOOST_REGEX)
 
 if(MSVC)
     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
 else()
     include(CheckCXXCompilerFlag)
     CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
+    CHECK_CXX_COMPILER_FLAG("-std=c++17" COMPILER_SUPPORTS_CXX17)
     if(!COMPILER_SUPPORTS_CXX11)
         message(FATAL_ERROR "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
     endif()
+    if(!COMPILER_SUPPORTS_CXX17)
+        message(WARNING "The compiler ${CMAKE_CXX_COMPILER} has no C++17 support. Some features (including PocoJSON support) may be unavailable.")
+    endif()
 
     # Suppress boost warnings that aren't relevant to the test suite
     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DBOOST_BIND_GLOBAL_PLACEHOLDERS")
 
-    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall")
+    if(COMPILER_SUPPORTS_CXX17)
+        SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17 -Wall")
+    elseif(COMPILER_SUPPORTS_CXX11)
+        SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall")
+    endif()
+
     SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0")
 endif()
 
@@ -36,6 +48,9 @@
 
 if(valijson_USE_EXCEPTIONS)
     target_compile_definitions(valijson INTERFACE -DVALIJSON_USE_EXCEPTIONS=1)
+endif()
+if (valijson_USE_BOOST_REGEX)
+    target_compile_definitions(valijson INTERFACE -DVALIJSON_USE_BOOST_REGEX=1)
 endif()
 
 install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
@@ -62,7 +77,7 @@
     add_compile_definitions(VALIJSON_USE_EXCEPTIONS=0)
 endif()
 
-find_package(Poco OPTIONAL_COMPONENTS JSON)
+find_package(Poco COMPONENTS Foundation JSON)
 find_package(Qt5Core)
 
 # jsoncpp library
@@ -113,6 +128,7 @@
 
     set(TEST_SOURCES
         tests/test_adapter_comparison.cpp
+        tests/test_date_time_format.cpp
         tests/test_fetch_absolute_uri_document_callback.cpp
         tests/test_fetch_urn_document_callback.cpp
         tests/test_json_pointer.cpp
@@ -126,6 +142,7 @@
         tests/test_validator.cpp
         tests/test_validator_with_custom_regular_expression_engine.cpp
         tests/test_yaml_cpp_adapter.cpp
+        tests/test_utf8_utils.cpp
     )
 
     set(TEST_LIBS gtest gtest_main jsoncpp json11 yamlcpp)
@@ -152,9 +169,14 @@
     endif()
 
     if(Poco_FOUND)
-        include_directories(${Poco_INCLUDE_DIRS})
-        list(APPEND TEST_SOURCES tests/test_poco_json_adapter.cpp)
-        list(APPEND TEST_LIBS ${Poco_Foundation_LIBRARIES} ${Poco_JSON_LIBRARIES})
+        if(COMPILER_SUPPORTS_CXX17)
+            list(APPEND TEST_SOURCES tests/test_poco_json_adapter.cpp)
+            list(APPEND TEST_LIBS
+                Poco::Foundation
+                Poco::JSON)
+        else()
+            message(WARNING "Poco found, but the compiler ${CMAKE_CXX_COMPILER} has no C++17 support. Poco will be disabled in this build.")
+        endif()
     endif()
 
     if(Qt5Core_FOUND)
@@ -178,7 +200,10 @@
     endif()
 
     if(NOT MSVC)
-        set_target_properties(test_suite PROPERTIES COMPILE_FLAGS " -pedantic -Werror -Wshadow -Wunused")
+        set_target_properties(test_suite PROPERTIES
+            COMPILE_FLAGS " -pedantic -Werror -Wshadow -Wunused"
+            CXX_STANDARD 17
+        )
     endif()
 
     if (MSVC)
@@ -230,6 +255,10 @@
         examples/array_iteration_template_fn.cpp
     )
 
+    add_executable(check_schema
+        examples/check_schema.cpp
+    )
+
     add_executable(object_iteration
         examples/object_iteration.cpp
     )
@@ -264,6 +293,7 @@
     target_link_libraries(external_schema ${Boost_LIBRARIES})
     target_link_libraries(array_iteration_basics jsoncpp)
     target_link_libraries(array_iteration_template_fn jsoncpp)
+    target_link_libraries(check_schema jsoncpp)
     target_link_libraries(object_iteration jsoncpp)
     target_link_libraries(json_pointers)
 endif()

=== debian/changelog ===
valijson (1.0.6+repack-0.1) unstable; urgency=medium

  * Non-maintainer upload
  * New upstream release (Closes: #1114430, #1113609)
  * Drop Expat license for JSON-Schema-Test-Suite

 -- Bastian Germann <bage@debian.org>  Tue, 16 Sep 2025 22:21:34 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,6 @@
 Maintainer: Dima Kogan <dkogan@debian.org>
 Build-Depends: cmake,
                debhelper-compat (= 13),
-               libjson11-1-dev,
                libjsoncpp-dev,
                nlohmann-json3-dev,
                picojson-dev,
@@ -12,7 +11,8 @@
                libpoco-dev,
                qtbase5-dev,
                rapidjson-dev,
-               libgtest-dev
+               libgtest-dev,
+               json-schema-test-suite
 Standards-Version: 4.6.0
 Homepage: https://github.com/tristanpenman/valijson
 Vcs-Git: https://salsa.debian.org/debian/valijson.git
@@ -21,7 +21,6 @@
 Package: libvalijson-dev
 Architecture: all
 Depends: ${misc:Depends}, ${shlibs:Depends},
-         libjson11-1-dev,
          libjsoncpp-dev,
          nlohmann-json3-dev,
          picojson-dev,

=== debian/rules ===
--- 
+++ 
@@ -25,7 +25,7 @@
 		-Dvalijson_EXCLUDE_BOOST=ON \
 		-Dvalijson_BUILD_TESTS=ON
 override_dh_auto_test:
-	cd obj-$(DEB_HOST_MULTIARCH) && ./test_suite
+	cd obj-$(DEB_HOST_GNU_TYPE) && ./test_suite
 
 # >>>>>>>>>>>>>>>>>>>>>>>
 else

=== debian/watch ===
version=4
opts=\
repacksuffix=+repack,\
dversionmangle=s/\+repack//g,\
repack,\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/valijson-$1\.tar\.gz/ \
 https://github.com/tristanpenman/valijson/tags .*/v(\d\S+)\.tar\.gz
